#%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%#
#  This Datapack was generated for private distribution only  #
# ----------------------------------------------------------- #
#                         DATAPACK INFO                       #
# ----------------------------------------------------------- #
#     Author: GenMode                                         #
#     URL: https://github.com/GenMode/Minecraft/wiki          #
#                                                             #
#%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%#


#---------- Adjust BurnTime ----------#
execute unless data block ~ ~ ~ Items[{Slot:1b}].tag.GenTag run function api:run/mechanic/light_furnace/init
execute if data block ~ ~ ~ Items[{Slot:1b}].tag.GenTag run data modify block ~ ~ ~ BurnTime set from block ~ ~ ~ Items[{Slot:1b}].tag.GenTag.Fuel.Ticks
execute unless data block ~ ~ ~ Items[{Slot:1b}].tag.GenTag run data modify block ~ ~ ~ BurnTime set value 801


#---------- Init ----------#

# Init
summon item ~ 0 ~ {PickupDelay:32767,Tags:["gen.Target"],Item:{id:"minecraft:item_frame",Count:1b,tag:{CustomModelData:1}}}
data modify entity @e[tag=gen.Target,limit=1] Item.tag.GenStorage set from block ~ ~ ~ {}

# Remove Count 1
scoreboard objectives add gen.Operation dummy
execute store result score @s gen.Operation run data get entity @e[tag=gen.Target,limit=1] Item.tag.GenStorage.Items[{Slot:1b}].Count
scoreboard players remove @s gen.Operation 1
execute store result entity @e[tag=gen.Target,limit=1] Item.tag.GenStorage.Items[{Slot:1b}].Count byte 1 run scoreboard players get @s gen.Operation

# Light Furnace
execute if block ~ ~ ~ minecraft:blast_furnace run function api:run/mechanic/light_furnace/setblock/blast_furnace
execute if block ~ ~ ~ minecraft:furnace run function api:run/mechanic/light_furnace/setblock/furnace
execute if block ~ ~ ~ minecraft:smoker run function api:run/mechanic/light_furnace/setblock/smoker

# Transfer Data
data modify block ~ ~ ~ Items set from entity @e[tag=gen.Target,limit=1] Item.tag.GenStorage.Items
data modify block ~ ~ ~ BurnTime set from entity @e[tag=gen.Target,limit=1] Item.tag.GenStorage.BurnTime
data modify block ~ ~ ~ CookTime set from entity @e[tag=gen.Target,limit=1] Item.tag.GenStorage.CookTime
data modify block ~ ~ ~ CookTimeTotal set from entity @e[tag=gen.Target,limit=1] Item.tag.GenStorage.CookTimeTotal
data modify block ~ ~ ~ RecipesUsed set from entity @e[tag=gen.Target,limit=1] Item.tag.GenStorage.RecipesUsed

# Close
scoreboard objectives remove gen.Operation
kill @e[tag=gen.Target]
data remove block ~ ~ ~ Items[{Slot:1b,tag:{GenTag:{CraftExclusive:1b}}}].tag.GenTag



