#%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%#
#  This Datapack was generated for private distribution only  #
# ----------------------------------------------------------- #
#                         DATAPACK INFO                       #
# ----------------------------------------------------------- #
#     Author: GenMode                                         #
#     Twitter: @DatapackGen                                   #
#     URL: https://github.com/GenMode/Minecraft/wiki          #
#                                                             #
#%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%#


# Scoreboard Event Detection
execute if entity @a[scores={gen.Install=1..}] as @a[scores={gen.Install=1..}] run function api:tools/version_change

# Tick Delay
function api:tools/delay1
function api:tools/delay2
function api:tools/delay3

# gen.Gadget (Delete Later)
execute if entity @a[nbt={SelectedItem:{tag:{gen.Gadget:1b}}}] as @a[nbt={SelectedItem:{tag:{gen.Gadget:1b}}}] if entity @s[nbt={}] at @s if entity @e[type=pig,distance=0..0.4] run function api:tools/gadget

#---------- Lib ----------#



# AI
execute as @e[tag=lib.AI] at @s run function api:lib/ai
kill @e[type=minecraft:item,nbt={Item:{tag:{GenTag:{GUI:1b}}}}]



#---------- Entity Tags ----------#




# gen.Crafter
execute as @e[tag=gen.Crafter] at @s run function api:run/tag_entity/crafter/version

# gen.FireRez
execute as @e[tag=gen.FireRez,nbt=!{ActiveEffects:[{Id:12b}]}] run effect give @s minecraft:fire_resistance 1000000 0 true

# gen.Immortal
execute as @e[tag=gen.Immortal,nbt=!{ActiveEffects:[{Id:11b}]}] run effect give @s minecraft:resistance 1 250 true

# gen.Invisible
execute as @e[tag=gen.Invisible,nbt=!{ActiveEffects:[{Id:14b}]}] run effect give @s minecraft:invisibility 1000000 0 true

# gen.Illuminate
execute as @e[tag=gen.Illuminate,nbt={Fire:0s}] run data merge entity @s {Fire:98303}
execute as @e[tag=gen.Illuminate,nbt={Fire:1s}] run data merge entity @s {Fire:98303}

# gen.Light
execute as @e[tag=gen.Light] at @s run function api:run/tag_entity/light_check



# gen.Pushable
execute as @e[tag=gen.Pushable] at @s if block ~ ~ ~ minecraft:piston_head run function api:run/tag_entity/pushable/push
execute as @e[tag=gen.Pushable] at @s run function api:run/tag_entity/pushable

# gen.Water_Breathing
execute as @e[tag=gen.Water_Breathing,nbt=!{ActiveEffects:[{Id:13b}]}] run effect give @s minecraft:water_breathing 1000000 0 true



#---------- Item Tags ----------#

# GenTag:{CraftExclusive:1b}
execute as @a[tag=!gen.InvNull,nbt={Inventory:[{tag:{GenTag:{CraftExclusive:1b}}}]}] at @s run function api:run/inventory/lib_revert

# GenTag:{Effect:{Saturation:X}}
execute as @a[scores={gen.Food_Sat=0..}] unless data entity @s SelectedItem.tag.GenTag.Effect.Saturation unless data entity @s Inventory[{Slot:-106b}].tag.GenTag.Effect.Saturation run scoreboard players reset @s gen.Food_Sat
execute as @a if data entity @s SelectedItem.tag.GenTag.Effect.Saturation store result score @s gen.Food_Sat run data get entity @s SelectedItem.tag.GenTag.Effect.Saturation
execute as @a unless data entity @s SelectedItem.tag.GenTag.Effect.Saturation if data entity @s Inventory[{Slot:-106b}].tag.GenTag.Effect.Saturation store result score @s gen.Food_Sat run data get entity @s Inventory[{Slot:-106b}].tag.GenTag.Effect.Saturation

# GenTag:{Fireproof:true}
execute as @e[type=item,nbt=!{Fire:-1s},nbt=!{Fire:0s},nbt={Item:{tag:{GenTag:{Fireproof:true}}}}] at @s run function api:run/mechanic/fireproof

# GenTag:{Type:"gen:gadget"} (Delete "unless part" after update)
execute as @a[scores={gen.Click=1..},nbt=!{SelectedItem:{tag:{GenTag:{Type:"gen:gadget"}}}}] unless entity @s[nbt={SelectedItem:{tag:{gen.Gadget:1b}}}] unless entity @s[nbt={SelectedItem:{tag:{gen.Gadget:1b}}}] run scoreboard players reset @s gen.Click
execute as @a[nbt={SelectedItem:{tag:{GenTag:{Type:"gen:gadget"}}},RootVehicle:{}}] at @s run function api:run/tag_item/gadget

# GenTag:{NoStack:true}
execute as @a[nbt={Inventory:[{tag:{GenTag:{NoStack:true}}}]}] at @s run function api:run/inventory/no_stack
execute as @e[nbt={Item:{tag:{GenTag:{NoStack:true}}}}] at @s run function api:run/tag_item/no_stack

# GenTag:{ReturnType:X}
execute as @a[scores={gen.ItemReturn=0..}] unless data entity @s SelectedItem.tag.GenTag.ReturnType run scoreboard players reset @s gen.ItemReturn
execute as @a store result score @s gen.ItemReturn if data entity @s SelectedItem.tag.GenTag.ReturnType run data get entity @s SelectedItem.tag.GenTag.ReturnType



#---------- Scores ----------#

# gen.Countdown
execute as @e[scores={gen.Countdown=0..}] at @s run function api:run/score/countdown

# gen.Hitbox
execute as @e[scores={gen.Hitbox=0..}] at @s run function api:run/score/hitbox

# gen.Shift
execute as @a[scores={gen.Shift=1..}] run scoreboard players reset @s gen.Shift









































#---------- New Lib ----------#

# Init
execute as @e[type=#api:init,tag=!api.Init] at @s run function api:run/tag_entity/init



#---------- New Entity Tags ----------#

# api.Name
execute as @e[type=minecraft:item_frame,tag=!api.Name] if data entity @s Item.tag.DataTag.Store.display.Name run function api:run/tag_entity/name
execute as @e[type=minecraft:item_frame,tag=api.Name] unless data entity @s Item run tag @s remove api.Name



#---------- New Scores ----------#

# api.CoaS
execute as @a[scores={api.CoaS=1..},nbt=!{SelectedItem:{tag:{DataTag:{Scores:["api.CoaS"]}}}}] run scoreboard players reset @s api.CoaS
execute as @a[nbt={SelectedItem:{tag:{DataTag:{Scores:["api.CoaS"]}}},RootVehicle:{}}] at @s run function api:run/tag_item/gadget

# api.Sneak_Time
execute as @a[scores={api.Sneak_Time=1..},nbt=!{SelectedItem:{tag:{DataTag:{Scores:["api.Sneak_Time"]}}}}] run scoreboard players reset @s api.Sneak_Time

# api.WFoaS
execute as @a[scores={api.WFoaS=1..},nbt=!{SelectedItem:{tag:{DataTag:{Scores:["api.WFoaS"]}}}}] run scoreboard players reset @s api.WFoaS
execute as @a[nbt={SelectedItem:{tag:{DataTag:{Scores:["api.WFoaS"]}}},RootVehicle:{}}] at @s run function api:run/tag_item/gadget















 